/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - б̿˨

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Mar.22.1999  褦ä
  Mar.23.1999  Ȥʤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit          -- ᥤץʤ
  RRMain              -- ֤˥뤵ᥤ
  RRMainFree          -- ᥤץཪλ()
  RRMainWindowSize    -- եå
  RRMainInterval      -- ߻֤
  RRMainIntervalTime  -- ߻֤ɤߤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <math.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "rr_spriteman.h"
#include  "lm_pix_rot.h"

/* --- եåǡ */
#include  "../picture/rose.xpm"
#include  "../picture/back.xpm"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  INTERVAL   10

/* - ̵ʥޥѥѤǤͤϰʲ SMOOTH_MODE 
     LM_PIXROT_SMOOTH ѹȲž鯤γˤʤ
     ޤ                                                      - */
#define  SMOOTH_MODE   LM_PIXROT_NORMAL

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  rose_work1(void);
void  rose_work2(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ǥץ쥤ݻ */
static gint  fw, fh;

/* --- ߤγ */
static gint  interval;
static gint  int_handle;
static gint  timer;

/* --- ǡ */
static GdkPixmap  *back = NULL;
static GdkPixbuf  *rose = NULL;
static GdkPixmap  *rose1 = NULL, *rose2 = NULL;
static GdkBitmap  *rose1_mask = NULL, *rose2_mask = NULL;

/* --- ץ饤ȥǡ */
static RRSObj  *back_spr;
static RRSObj  *rose1_spr;
static RRSObj  *rose2_spr;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  int_handle = 0;

  timer = 0;

  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-16-*-*-*-*-*-*-*,\
            -*-*-medium-*-normal-*-16-*-*-*-*-*-jisx0208.1983-0");

  RRSpritemanInit();

  /* -- GdkRGB ν */
  gdk_rgb_init();

  /* -- ߳ */
  RRMainInterval(INTERVAL);

  /* -- ץ饤Ƚ */
  back_spr = RRSpritemanBGNew();
  rose1_spr = RRSpritemanNew();
  rose2_spr = RRSpritemanNew();

  /* --  */
  RRMainWindowSize(320, 200);
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (rose != NULL) gdk_pixbuf_unref(rose);
  if (back != NULL) gdk_pixmap_unref(back);
  if (rose1 != NULL) gdk_pixmap_unref(rose1);
  if (rose2 != NULL) gdk_pixmap_unref(rose2);
  RRSpritemanFree();
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  GdkPixbuf  *b1, *b2, *r1;
  GdkGC     *gc;
  gfloat  mw, mh;
  gint    rw, rh;

  fw = w;
  fh = h;
  /* --- طʤΥꥵ */
  if (back != NULL) gdk_pixmap_unref(back);
  if (RRScreenIsRoot() == FALSE) {
    back = gdk_pixmap_new(RRScreenWindow()->window, fw, fh, -1);
  }
  else {
    back = gdk_pixmap_new(RRScreenRoot(), fw, fh, -1);
  }
  gc = gdk_gc_new(back);
  b1 = gdk_pixbuf_new_from_xpm_data((const char **)back_xpm);
  b2 = gdk_pixbuf_new(GDK_COLORSPACE_RGB, TRUE, 8, fw, fh);
  mw = (gfloat)(fw / 1024.0);
  mh = (gfloat)(fh / 768.0);
  gdk_pixbuf_scale(b1, b2, 0, 0, fw, fh, 0, 0, mw, mh, GDK_INTERP_HYPER);
  gdk_pixbuf_render_to_drawable(b2, back, gc,
				0, 0, 0, 0, fw, fh,
				GDK_RGB_DITHER_NONE, 0, 0);

  gdk_gc_destroy(gc);
  gdk_pixbuf_unref(b1);
  gdk_pixbuf_unref(b2);
  back_spr->sw = TRUE;
  back_spr->update = TRUE;
  back_spr->z = 100;
  back_spr->obj.sw = TRUE;
  back_spr->obj.mask_offset = TRUE;
  back_spr->obj.objmap = back;
  back_spr->obj.objmask = FALSE;
  back_spr->obj.x = 0;
  back_spr->obj.y = 0;
  back_spr->obj.w = fw;
  back_spr->obj.h = fh;
  back_spr->obj.ox = 0;
  back_spr->obj.oy = 0;
  back_spr->obj.offset_x = 0;
  back_spr->obj.offset_y = 0;


  /* --- 鯤Υꥵ */
  rw =(gint)(521.0 * (mw / 2));
  rh =(gint)(488.0 * (mw / 2));
  r1 = gdk_pixbuf_new_from_xpm_data((const char **)rose_xpm);
  rose = gdk_pixbuf_new(GDK_COLORSPACE_RGB, TRUE, 8, rw, rh);
  gdk_pixbuf_scale(r1, rose, 0, 0, rw, rh, 0, 0, mw/2, mw/2, GDK_INTERP_HYPER);
  gdk_pixbuf_unref(r1);
}


/* -------------------------------------------------------------
  RRMainInterval   -- ߻֤

   return : void
   gint n(n sec)
-------------------------------------------------------------- */
void RRMainInterval(gint n)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  int_handle = gtk_timeout_add(1000/n, (GtkFunction)RRMain, NULL);
  /* --- ͤݻ */
  interval = n;
}


/* -------------------------------------------------------------
  RRMainIntervalTime  -- ߻֤ɤߤ

   return : n (1/n sec)
   void
-------------------------------------------------------------- */
gint RRMainIntervalTime(void)
{
  return(interval);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  timer++;

  /* --- 鯤뤯 */
  rose_work1();
  rose_work2();

  /* ---  */
  RRSpritemanUpdate();

  /* --- Graphic Buffer Υå */
  if (RRScreenWindow() != NULL) {
    RRScreenSwitch();
  }
  else {
    RRScreenSwitchRoot();
  }

  return 1;
}


/* -------------------------------------------------------------
  rose_work()  -- 鯤βž
-------------------------------------------------------------- */
void  rose_work1(void)
{
  GdkPixbuf *rot1;
  gint  w, h;
  gfloat  r;

  /* --- 鯤βž */
  r = M_PI * 2 / 120 * (timer % 120);
  rot1 = lm_pix_rot_new(rose, r, 1.0, SMOOTH_MODE);

  /* --- 鯤ɽ³ 1 */
  w = gdk_pixbuf_get_width(rot1);
  h = gdk_pixbuf_get_height(rot1);
  if (rose1 != NULL) gdk_pixmap_unref(rose1);
  if (rose1_mask != NULL) gdk_pixmap_unref(rose1_mask);
  gdk_pixbuf_render_pixmap_and_mask(rot1, &rose1, &rose1_mask, 0xc0);
  rose1_spr->sw = TRUE;
  rose1_spr->update = TRUE;
  rose1_spr->z = 10;
  rose1_spr->obj.sw = TRUE;
  rose1_spr->obj.mask_offset = TRUE;
  rose1_spr->obj.objmap = rose1;
  rose1_spr->obj.objmask = rose1_mask;
  rose1_spr->obj.x = (120 * fw / 1024);
  rose1_spr->obj.y = (120 * fh / 768);
  rose1_spr->obj.w = w;
  rose1_spr->obj.h = h;
  rose1_spr->obj.ox = 0;
  rose1_spr->obj.oy = 0;
  rose1_spr->obj.offset_x = w/2;
  rose1_spr->obj.offset_y = h/2;
  gdk_pixbuf_unref(rot1);

}

void  rose_work2(void)
{
  GdkPixbuf *rot2;
  gint  w, h;
  gfloat  r;

  /* --- 鯤βž */
  r = M_PI * 2 / 120 * (timer % 120);
  rot2 = lm_pix_rot_new(rose, -r, 1.0, SMOOTH_MODE);

  /* --- 鯤ɽ³ 2 */
  w = gdk_pixbuf_get_width(rot2);
  h = gdk_pixbuf_get_height(rot2);
  if (rose2 != NULL) gdk_pixmap_unref(rose2);
  if (rose2_mask != NULL) gdk_pixmap_unref(rose2_mask);
  gdk_pixbuf_render_pixmap_and_mask(rot2, &rose2, &rose2_mask, 0xc0);
  rose2_spr->sw = TRUE;
  rose2_spr->update = TRUE;
  rose2_spr->z = 10;
  rose2_spr->obj.sw = TRUE;
  rose2_spr->obj.mask_offset = TRUE;
  rose2_spr->obj.objmap = rose2;
  rose2_spr->obj.objmask = rose2_mask;
  rose2_spr->obj.x = ((1024 - 120) * fw / 1024);
  rose2_spr->obj.y = ((768 - 120) * fh / 768);
  rose2_spr->obj.w = w;
  rose2_spr->obj.h = h;
  rose2_spr->obj.ox = 0;
  rose2_spr->obj.oy = 0;
  rose2_spr->obj.offset_x = w/2;
  rose2_spr->obj.offset_y = h/2;
  gdk_pixbuf_unref(rot2);
}

